package ru.ifmo.tracklayer.ep;

import com.evelopers.common.exception.CommonException;
import com.evelopers.unimod.core.stateworks.Event;
import com.evelopers.unimod.runtime.EventProvider;
import com.evelopers.unimod.runtime.ModelEngine;
import com.evelopers.unimod.runtime.context.Parameter;
import com.evelopers.unimod.runtime.context.StateMachineContextImpl;

public class TracklayerEventProvider implements EventProvider {
	
	/**
	 * @unimod.event.descr Bad track found
	 */
    public static final String E200 = "e200";
    
    /**
	 * @unimod.event.descr No track found
	 */
    public static final String E201 = "e201";
    
    /**
	 * @unimod.event.descr End of line found
	 */
    public static final String E202 = "e202";
    
    /**
	 * @unimod.event.descr Operation complete
	 */
    public static final String E203 = "e203";
    
    /**
	 * @unimod.event.descr Store is full
	 */
    public static final String E204 = "e204";

	private static ModelEngine engine;
	
	public void init(ModelEngine engine) throws CommonException {
		TracklayerEventProvider.engine = engine;
	}
	
	private static void fireEvent(String eventName, Parameter parameter) {
	    if (engine != null) {
	    	if (parameter == null) {
	    		engine.getEventManager().handle(new Event(eventName), StateMachineContextImpl.create());
	    	} else {
	    		engine.getEventManager().handle(new Event(eventName, new Parameter[]{parameter}), StateMachineContextImpl.create());
	    	}
	    }
    }

	public void dispose() {
		// TODO Auto-generated method stub

	}

	public static void badFound() {
		fireEvent(E200, null);
	}

	public static void noneFound() {
		fireEvent(E201, null);
	}
	
	public static void endFound() {
		fireEvent(E202, null);
	}
	
	public static void operationComplete() {
		fireEvent(E203, null);
	}

	public static void storeIsFull() {
		fireEvent(E204, null);
	}
}
